//---------------------------------------------------------------------------
// w32front.cpp - a Borland C++Builder front end to some of the
//		functions in the Win32 SDK.
#include <vcl\vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
AnsiString GetClassNameX(HWND handle)
/*
	Returns a window's class or empty string if not found
*/
{
	char *buff;
    UINT size;
    AnsiString result = "";
	// error trap
    if (handle==NULL || !IsWindow(handle))	return result;
    // first get required size of string
	#pragma warn -def	// disable warning about buff
	size = GetClassName(handle,buff,0);
	#pragma warn .def	// re-enable warnings
	// if window found and non-empty title
    if (size) {    // then build string and put path in it
    	buff = new char[size];
		GetClassName(handle,buff,size);
		result = AnsiString(buff);
	    // and release character string
	    delete [] buff;
    }
    return result;
}
//---------------------------------------------------------------------------
HWND GetFocusX(void)
/*
	Gets the handle of the window/component which currently has focus.
    Extends the win32 API GetFocus by working for windows owned by a
    different thread.  Returns NULL on failure.

    This code is due to Gregory A. Wolking of PC Magazine (kind of).
*/
{
	HWND result;
    DWORD fgProcessId;
    bool isAttached = false;

    DWORD fgId = GetWindowThreadProcessId(GetForegroundWindow(),&fgProcessId);
    DWORD myId = GetCurrentThreadId();
	// if thread of foreground window not this thread
    if (myId != fgId) {
	    // need to attach input
    	isAttached = AttachThreadInput(myId, fgId, true);
    }
    // now ready to get focus, regardless of which window is in foreground
	result = GetFocus();
    // clean-up
	if (isAttached)	AttachThreadInput(myId, fgId, false);
    return result;
}
//---------------------------------------------------------------------------
AnsiString GetFullPathNameX(AnsiString f)
/*
	Returns the full path and (long) file name from a short/incomplete
    path.  As it stands this routine should be able to handle any number
    of characters up to max(DWORD).
*/
{
	char *buff;
    DWORD size;
    AnsiString result;
    char *filepart;
    // first get required size of string
	#pragma warn -def	// disable warning about buff
	size = GetFullPathName(f.c_str(),0,buff,&filepart);
	#pragma warn .def	// re-enable warnings
    // then build string and put path in it
    buff = new char[size];
	GetFullPathName(f.c_str(),size,buff,&filepart);
	result = AnsiString(buff);
    // and release character string
    delete [] buff;
    return result;
}
//---------------------------------------------------------------------------
AnsiString GetWindowsDirectoryX(void)
/*
	Returns the Windows root folder
*/
{
	char *buff;
    UINT size;
    AnsiString result;
    // first get required size of string
	#pragma warn -def	// disable warning about buff
	size = GetWindowsDirectory(buff,0);
	#pragma warn .def	// re-enable warnings
    // then build string and put path in it
    buff = new char[size];
	GetWindowsDirectory(buff,size);
	result = AnsiString(buff);
    // and release character string
    delete [] buff;
    return result;
}
//---------------------------------------------------------------------------
AnsiString GetWindowTextX(HWND handle)
/*
	Returns a window's title or empty string if not found
*/
{
	char *buff;
    UINT size;
    AnsiString result = "";
	// error trap
    if (handle==NULL || !IsWindow(handle))	return result;
    // first get required size of string
	size = GetWindowTextLength(handle);
	// if window found and non-empty title
    if (size++) {    // then build string (increment size for "\0")
    	buff = new char[size];
		GetWindowText(handle,buff,size);
		result = AnsiString(buff);
	    // and release character string
	    delete [] buff;
    }
    return result;
}
//---------------------------------------------------------------------------

